(*
   This file is part of Anoq's simple implementation of CeXL.
   CeXL is a programming language developed by Anoq of the Sun
   at Hardcore Processing.

   Copyright (C) 2003-2010 Anoq of the Sun (alias Johnny Bock Andersen)

   Contact: http://www.hardcoreprocessing.com/contact

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you are interested in a warranty or commercial support for this
   software, contact Hardcore Processing for more information at:
   http://www.hardcoreprocessing.com/contact

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

structure TestCeXL1Abs =
  struct
    structure A = CeXL1Abs

    fun testFWhile1 () =
          case A.makeExpFWhile
                 (A.ExpConst {const = KsiAbs.SCInt 1, ann = ()})
                 nil [{vid = "a",
                       exp = A.ExpConst
                              {const = KsiAbs.SCString "Hello", ann = ()},
                       ann = ()}]
                 "x" () of
            A.ExpLet
              {decs = [A.DecVal {tyParams, isRec = true,
                                 binds = [{pat, exp, ann = _}],
                                 ann = _}],
               exp = A.ExpApp {funExp = A.ExpLongVid {longVid = "x", ann = _},
                               argExp, ann = _},
               ann = _} =>
                (case pat of
                   A.PatLongVid {longVid = "x", ann = _} =>
                       (case argExp of
                          A.ExpRecord
                            {fields = [{lab = "a",
                                        isOpt = false,
                                        exp = A.ExpLongVid
                                                {longVid = "a",
                                                 ann = _},
                                        ann = _}],
                             ext = NONE,
                             ann = _} =>
                              (case exp of
                                 A.ExpFun
                                   {matches =
                                      [{pat = A.PatRecord
                                                {fields =
                                                   [{isOpt = false,
                                                     lab = "a",
                                                     pat = A.PatLongVid
                                                             {longVid = "a",
                                                              ann = _},
                                                     ann = _}],
                                                 isExt = false,
                                                 ext = NONE,
                                                 ann = _},
                                        exp = ifExp,
                                        ann = _}],
                                    ann = _} =>
                                     (case ifExp of
                                        A.ExpCase
                                          {exp = A.ExpConst {const = KsiAbs.SCInt 1, ann = _},
                                           matches =
                                             [{pat = A.PatLongVid {longVid = "true", ann = _},
                                               exp = trueExp,
                                               ann = _},
                                              {pat = A.PatLongVid {longVid = "false", ann = _},
                                               exp = A.ExpRecord
                                                       {fields =
                                                          [{isOpt = false,
                                                            lab = "a",
                                                            exp = A.ExpLongVid {longVid = "a", ann = _},
                                                            ann = _}],
                                                        ext = NONE,
                                                        ann = _},
                                               ann = _}],
                                           ann = _} =>
                                            (case trueExp of
                                               A.ExpLet
                                                 {decs = nil,
                                                  exp = A.ExpApp
                                                          {funExp = A.ExpLongVid {longVid = "x", ann = _},
                                                           argExp = A.ExpRecord
                                                                      {fields =
                                                                         [{isOpt = false,
                                                                           lab = "a",
                                                                           exp = A.ExpConst
                                                                                   {const = KsiAbs.SCString "Hello", ann = _},
                                                                           ann = _}],
                                                                       ext = NONE,
                                                                       ann = _},
                                                           ann = _},
                                                  ann = _} =>
                                                   true
                                             | _ =>
                                                   (print "Error 6 in testFWhile1";
                                                    false)
                                            )
                                      | _ =>
                                            (print "Error 5 in testFWhile1";
                                             false)
                                     )
                               | _ =>
                                     (print "Error 4 in testFWhile1";
                                      false)
                              )
                        | _ =>
                              (print "Error 3 in testFWhile1";
                               false)
                       )
                 | _ =>
                       (print "Error 2 in testFWhile1";
                        false)
                )
          | _ =>
                (print "Error 1 in testFWhile1";
                 false)

    fun testFValBind1 () =
          case A.makeFValBind
                 [{vid = "not", pats = [A.PatLongVid {longVid = "true", ann = ()}],
                   ty = NONE, exp = A.ExpLongVid {longVid = "false", ann = ()}, ann = ()},
                  {vid = "not", pats = [A.PatLongVid {longVid = "false", ann = ()}],
                   ty = NONE, exp = A.ExpLongVid {longVid = "true", ann = ()}, ann = ()}]
                 (fn () => "x") () of
            {pat = A.PatLongVid {longVid = "not", ann = _},
             exp,
             ann = _} =>
                (case exp of
                   A.ExpFun {matches = [{pat = A.PatLongVid {longVid = "x", ann = _},
                                         exp = bodyExp, ann = _}], ann = _} =>
                       (case bodyExp of
                          A.ExpCase
                            {exp = A.ExpLongVid {longVid = "x", ann = _},
                             matches = [{pat = pat1, exp = exp1, ann = _},
                                        {pat = pat2, exp = exp2, ann = _}],
                             ann = _} =>
                              (case (pat1, pat2) of
                                 (A.PatLongVid {longVid = "true", ann = _},
                                  A.PatLongVid {longVid = "false", ann = _}) =>
                                     (case (exp1, exp2) of
                                        (A.ExpLongVid {longVid = "false", ann = _},
                                         A.ExpLongVid {longVid = "true", ann = _}) =>
                                            true
                                      | _ =>
                                            (print "Error 5 in testFValBind1";
                                             false)
                                     )
                               | _ =>
                                     (print "Error 4 in testFValBind1";
                                      false)
                              )
                        | _ =>
                              (print "Error 3 in testFValBind1";
                               false)
                       )
                 | _ =>
                       (print "Error 2 in testFValBind1";
                        false)
                )
          | _ =>
                (print "Error 1 in testFValBind1";
                 false)

    fun testPatTuple1 () =
          case A.makePatTuple [A.PatLongVid {longVid = "true", ann = ()}] () of
            A.PatLongVid {longVid = "true", ann = ()} =>
              true
          | _ =>
              false

    fun testPatTuple2 () =
          case A.makePatTuple [A.PatLongVid {longVid = "true", ann = ()},
                               A.PatLongVid {longVid = "false", ann = ()}] () of
            A.PatRecord
              {fields = [{isOpt = false,
                          lab = "1",
                          pat = A.PatLongVid {longVid = "true", ann = ()},
                          ann = _},
                         {isOpt = false,
                          lab = "2",
                          pat = A.PatLongVid {longVid = "false", ann = ()},
                          ann = _}],
               isExt = false,
               ext = NONE,
               ann = ann} =>
                true
          | _ =>
                false

    fun testExpTuple1 () =
          case A.makeExpTuple [A.ExpLongVid {longVid = "true", ann = ()}] () of
            A.ExpLongVid {longVid = "true", ann = ()} =>
              true
          | _ =>
              false

    fun testExpTuple2 () =
          case A.makeExpTuple [A.ExpLongVid {longVid = "true", ann = ()},
                               A.ExpLongVid {longVid = "false", ann = ()}] () of
            A.ExpRecord
              {fields = [{isOpt = false,
                          lab = "1",
                          exp = A.ExpLongVid {longVid = "true", ann = ()},
                          ann = _},
                         {isOpt = false,
                          lab = "2",
                          exp = A.ExpLongVid {longVid = "false", ann = ()},
                          ann = _}],
               ext = NONE,
               ann = ann} =>
                true
          | _ =>
                false
    
    fun test () =
          TestUtil.doTest
            [("testFWhile1", testFWhile1),
             ("testFValBind1", testFValBind1),
             ("testPatTuple1", testPatTuple1),
             ("testPatTuple2", testPatTuple2),
             ("testExpTuple1", testExpTuple1),
             ("testExpTuple2", testExpTuple2)
            ]
  end
