(*
   This file is part of Anoq's simple implementation of CeXL.
   CeXL is a programming language developed by Anoq of the Sun
   at Hardcore Processing.

   Copyright (C) 2003-2010 Anoq of the Sun (alias Johnny Bock Andersen)

   Contact: http://www.hardcoreprocessing.com/contact

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you are interested in a warranty or commercial support for this
   software, contact Hardcore Processing for more information at:
   http://www.hardcoreprocessing.com/contact

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

signature UTIL =
  sig
    exception RangeError (* FIXME: Use general error handling or SML exceptions? *)

    (* A "finally" clause for handling exceptions (similar to those
       found in Java and Borland's "Delphi" Pascal dialect).
       Ought to be part of Standard ML in my opinion... *)
    (* But, alas, it is not - so I had to write this method *)
    val finalize : (unit -> 'a) -> (unit -> 'b) -> 'a

    val optionMap : ('a -> 'b) -> 'a option -> 'b option

    val foldlsep : ('b -> 'b) -> (('a * 'b) -> 'b) -> 'b -> 'a list -> 'b

    val indexAccl : (int * 'a -> 'a) -> 'a -> int -> 'a
    val indexAccr : (int * 'a -> 'a) -> 'a -> int -> 'a

    val quickSort : (('a * 'a) -> bool) -> 'a list -> 'a list

    val mergeSorted : (('a * 'a) -> bool) -> 'a list -> 'a list -> 'a list

    val removeSortedDuplicates : ('a * 'a -> bool) -> 'a list -> 'a list

    val isSortedDistinct : ('a * 'a -> bool) -> 'a list -> bool

    val hasSortedDuplicates : ('a * 'a -> bool) -> 'a list -> bool

    val getSortedDuplicates : ('a * 'a -> bool) -> 'a list -> 'a list
  end
